import numpy as np

# The dataset. This is just an example generated with N(3.2, 1.1).
x = [3.98854554, 4.18610834, 3.79048213, 3.40307277, 2.52976334,
     3.52700584, 3.70533666, 3.75593724, 1.90099852, 5.21032427]

# 1. Readout statistic
def mu_hat(x):
    return np.mean(x)
def sigma_hat(x):
    return np.sqrt(np.mean((x-mu_hat(x))**2))

# 2. Function to generate dataset using parametric resampling.
def rx_par():
    return np.random.normal(loc=mu_hat(x), scale=sigma_hat(x), size=len(x))

# 3. (a) Generate datasets and estimate st. deviation in each.
sigma_hat_par = [sigma_hat(rx_par()) for _ in range(10000)]
#    (b) Find the confidence interval.
lo_par, hi_par = np.quantile(sigma_hat_par, [.025, .975])

print(f"Confidence interval: [{lo_par}, {hi_par}]")
# One possible output:
# Confidence interval: [0.4397..., 1.1721...]
