import numpy as np
import matplotlib.pyplot as plt

# The two given datasets X_i ~ Po(mu) and Y_i ~ Po(nu).
x = [3, 1, 5]
y = [2, 3]

# MLE estimates for mu and nu.
mu_hat = np.mean(x)
nu_hat = np.mean(y)

# Estimating the quantity of interest.
def t(x,y):
    return np.mean(y) - np.mean(x)
# Resampling from the Poisson distributions.
def rxy():
    return (np.random.poisson(mu_hat, size=len(x)),
            np.random.poisson(nu_hat, size=len(y)))

t_ = np.array([t(*rxy()) for _ in range(10000)])
lo, hi = np.quantile(t_, [.025, .975])

print(f"Confidence interval: [{lo}, {hi}]")
# One possible output:
# Confidence interval: [-3.333..., 2.5].
