import numpy as np

theta = 2
num_samples = 1000

def parametric_conf_interval(samples):
    theta_mle = np.max(samples)

    thetas = np.array([np.max(theta_mle * np.random.random(len(samples))) for _ in range(10000)])
    return np.quantile(thetas, [.025, .975])


def non_parametric_conf_interval(samples):
    thetas = np.array([np.max(np.random.choice(samples, size=len(samples))) for _ in range(10000)])
    return np.quantile(thetas, [.025, .975])


samples = theta * np.random.random(num_samples)
print(f"Parametric confidence interval: [{parametric_conf_interval(samples)}]")
print(f"Non-parametric confidence interval: [{non_parametric_conf_interval(samples)}]")

# One possible output:
# Parametric confidence interval: [[1.992... 1.999...]]
# Non-parametric confidence interval: [[1.998... 1.999... ]]
